'
' This file is part of VECTO-Engine.
'
' Copyright © 2012-2017 European Union
'
' Developed by Graz University of Technology,
'              Institute of Internal Combustion Engines and Thermodynamics,
'              Institute of Technical Informatics
'
' VECTO is licensed under the EUPL, Version 1.1 or - as soon they will be approved
' by the European Commission - subsequent versions of the EUPL (the "Licence");
' You may not use VECTO except in compliance with the Licence.
' You may obtain a copy of the Licence at:
'
' https://joinup.ec.europa.eu/community/eupl/og_page/eupl
'
' Unless required by applicable law or agreed to in writing, VECTO
' distributed under the Licence is distributed on an "AS IS" basis,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the Licence for the specific language governing permissions and
' limitations under the Licence.
'
' Authors:
'   Stefan Hausberger, hausberger@ivt.tugraz.at, IVT, Graz University of Technology
'   Raphael Luz, luz@ivt.tugraz.at, IVT, Graz University of Technology
'   Markus Quaritsch, markus.quaritsch@tugraz.at, IVT, Graz University of Technology
'   Martin Rexeis, rexeis@ivt.tugraz.at, IVT, Graz University of Technology
'   Gérard Silberholz, silberholz@ivt.tugraz.at, IVT, Graz University of Technology
'
Imports System.IO

''' <summary>
'''     Engine input file
''' </summary>
''' <remarks></remarks>
Public Class cENG
	''' <summary>
	'''     Current format version
	''' </summary>
	''' <remarks></remarks>
	Private Const FormatVersion As Short = 2

	''' <summary>
	'''     Format version of input file. Defined in ReadFile.
	''' </summary>
	''' <remarks></remarks>
	Private FileVersion As Short

	''' <summary>
	'''     Engine description (model, type, etc.). Saved in input file.
	''' </summary>
	''' <remarks></remarks>
	Public ModelName As String

	''' <summary>
	'''     Engine displacement [ccm]. Saved in input file.
	''' </summary>
	''' <remarks></remarks>
	Public Displ As Double

	''' <summary>
	'''     Idling speed [1/min]. Saved in input file.
	''' </summary>
	''' <remarks></remarks>
	Public Nidle As Double

	''' <summary>
	'''     Rotational inertia including flywheel [kgm²]. Saved in input file. Overwritten by generic value in Declaration
	'''     mode.
	''' </summary>
	''' <remarks></remarks>
	Public I_mot As Double

	''' <summary>
	'''     List of full load/motoring curve files (.vfld)
	''' </summary>
	''' <remarks></remarks>
	Public fFLD As List(Of cSubPath)

	''' <summary>
	'''     Path to fuel consumption map
	''' </summary>
	''' <remarks></remarks>
	Private ReadOnly fMAP As cSubPath

	''' <summary>
	'''     List of gear-assignments for the given .vfld files.
	''' </summary>
	''' <remarks></remarks>
	Public FLDgears As List(Of String)

	''' <summary>
	'''     Directory of engine file. Defined in FilePath property (Set)
	''' </summary>
	''' <remarks></remarks>
	Private MyPath As String

	''' <summary>
	'''     Full file path. Needs to be defined via FilePath property before calling ReadFile or SaveFile.
	''' </summary>
	''' <remarks></remarks>
	Private sFilePath As String

	''' <summary>
	'''     List of sub input files (e.g. FC map). Can be accessed by FileList property. Generated by CreateFileList.
	''' </summary>
	''' <remarks></remarks>
	Private MyFileList As List(Of String)

	''' <summary>
	'''     WHTC Urban test results. Saved in input file.
	''' </summary>
	''' <remarks></remarks>
	Public WHTCurban As Double

	''' <summary>
	'''     WHTC Rural test results. Saved in input file.
	''' </summary>
	''' <remarks></remarks>
	Public WHTCrural As Double

	''' <summary>
	'''     WHTC Motorway test results. Saved in input file.
	''' </summary>
	''' <remarks></remarks>
	Public WHTCmw As Double

	''' <summary>
	'''     Rated engine speed [1/min]. Engine speed at max. power. Defined in Init.
	''' </summary>
	''' <remarks></remarks>
	Public Nrated As Double

	''' <summary>
	'''     Maximum engine power [kW]. Power at rated engine speed.
	''' </summary>
	''' <remarks></remarks>
	Public Pmax As Double

	Public SavedInDeclMode As Boolean


	''' <summary>
	'''     Generates list of all sub input files (e.g. FC map). Sets MyFileList.
	''' </summary>
	''' <returns>True if successful.</returns>
	''' <remarks></remarks>
	Public Function CreateFileList() As Boolean
		Dim sb As cSubPath

		MyFileList = New List(Of String)

		For Each sb In Me.fFLD
			MyFileList.Add(sb.FullPath)
		Next

		MyFileList.Add(PathMAP)

		'Not used!!! MyFileList.Add(PathWHTC)

		Return True
	End Function

	''' <summary>
	'''     New instance. Initialise
	''' </summary>
	''' <remarks></remarks>
	Public Sub New()
		MyPath = ""
		sFilePath = ""
		fMAP = New cSubPath
		SetDefault()
	End Sub

	''' <summary>
	'''     Set default values
	''' </summary>
	''' <remarks></remarks>
	Private Sub SetDefault()
		ModelName = "Undefined"
		Displ = 0
		Nidle = 0
		I_mot = 0
		Nrated = 0
		Pmax = 0

		fFLD = New List(Of cSubPath)
		FLDgears = New List(Of String)

		fMAP.Clear()

		WHTCurban = 0
		WHTCrural = 0
		WHTCmw = 0

		SavedInDeclMode = False
	End Sub



	''' <summary>
	'''     Get or set file path (cSubPath) to FC map (.vmap)
	''' </summary>
	''' <param name="Original">True= (relative) file path as saved in file; False= full file path</param>
	''' <value></value>
	''' <returns>Relative or absolute file path to FC map</returns>
	''' <remarks></remarks>
	Public Property PathMAP(Optional ByVal Original As Boolean = False) As String
		Get
			If Original Then
				Return fMAP.OriginalPath
			Else
				Return fMAP.FullPath
			End If
		End Get
		Set
			fMAP.Init(MyPath, value)
		End Set
	End Property
End Class
